<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SR_Movimiento.xml */
/* Generado: 2021-08-25 23:09:49 */

/* Mantenimiento de los registros de la tabla SR_Movimiento */
abstract class BaseSR_MovimientoDP extends SR_MovimientoBV
{
    /* Constructor ( Establece los valores desde un objeto SR_MovimientoBN ) */
    public function __construct( SR_MovimientoBN $o_SR_MovimientoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SR_MovimientoBN ) )
        {
            $this->setByBN( $o_SR_MovimientoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SR_MovimientoBN */
    public function setByBN( SR_MovimientoBN $o_SR_MovimientoBN )
    {
        if ( !is_null( $o_SR_MovimientoBN->getMovimientoId() ) )
        {
            $this->setMovimientoId( $o_SR_MovimientoBN->getMovimientoId() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SR_MovimientoBN->getIdCompania() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_SR_MovimientoBN->getIdSucursal() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getFecha() ) )
        {
            $this->setFecha( $o_SR_MovimientoBN->getFecha() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getTipoMovimiento() ) )
        {
            $this->setTipoMovimiento( $o_SR_MovimientoBN->getTipoMovimiento() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getOperacion() ) )
        {
            $this->setOperacion( $o_SR_MovimientoBN->getOperacion() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getAlmacen() ) )
        {
            $this->setAlmacen( $o_SR_MovimientoBN->getAlmacen() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getReferenciaTipo() ) )
        {
            $this->setReferenciaTipo( $o_SR_MovimientoBN->getReferenciaTipo() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getReferenciaNumero() ) )
        {
            $this->setReferenciaNumero( $o_SR_MovimientoBN->getReferenciaNumero() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getReferenciaSecuencia() ) )
        {
            $this->setReferenciaSecuencia( $o_SR_MovimientoBN->getReferenciaSecuencia() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getReferenciaId() ) )
        {
            $this->setReferenciaId( $o_SR_MovimientoBN->getReferenciaId() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getReferenciaFecha() ) )
        {
            $this->setReferenciaFecha( $o_SR_MovimientoBN->getReferenciaFecha() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getInicioEscaneo() ) )
        {
            $this->setInicioEscaneo( $o_SR_MovimientoBN->getInicioEscaneo() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getFinEscaneo() ) )
        {
            $this->setFinEscaneo( $o_SR_MovimientoBN->getFinEscaneo() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getComentario() ) )
        {
            $this->setComentario( $o_SR_MovimientoBN->getComentario() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getUsuarioAprob() ) )
        {
            $this->setUsuarioAprob( $o_SR_MovimientoBN->getUsuarioAprob() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getFechaAprob() ) )
        {
            $this->setFechaAprob( $o_SR_MovimientoBN->getFechaAprob() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getEstadoAprob() ) )
        {
            $this->setEstadoAprob( $o_SR_MovimientoBN->getEstadoAprob() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getComentarioAprob() ) )
        {
            $this->setComentarioAprob( $o_SR_MovimientoBN->getComentarioAprob() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getEstado() ) )
        {
            $this->setEstado( $o_SR_MovimientoBN->getEstado() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getImpresionEstado() ) )
        {
            $this->setImpresionEstado( $o_SR_MovimientoBN->getImpresionEstado() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getControlEstadoSerie() ) )
        {
            $this->setControlEstadoSerie( $o_SR_MovimientoBN->getControlEstadoSerie() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_SR_MovimientoBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_SR_MovimientoBN->getFechaRegistro() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SR_MovimientoBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_SR_MovimientoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SR_MovimientoBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SR_MovimientoFN = new SR_MovimientoFN();
        $o_SR_MovimientoBN = $o_SR_MovimientoFN->selectByPk( $this->getMovimientoId() );
        if ( is_null( $o_SR_MovimientoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SR_Movimiento ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getMovimientoId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."MovimientoId";
                $s_SQLQuery2 .= $s_Separator."".$this->getMovimientoId()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Fecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoMovimiento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoMovimiento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoMovimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOperacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Operacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getOperacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAlmacen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Almacen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaTipo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumero() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaNumero";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaSecuencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getReferenciaSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaId() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaId";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ReferenciaFecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getReferenciaFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioEscaneo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."InicioEscaneo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getInicioEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinEscaneo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FinEscaneo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFinEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Comentario";
                $s_SQLQuery2 .= $s_Separator."'".$this->getComentario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioAprob() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioAprob";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaAprob() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaAprob";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoAprob() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoAprob";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioAprob() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ComentarioAprob";
                $s_SQLQuery2 .= $s_Separator."'".$this->getComentarioAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpresionEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ImpresionEstado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getImpresionEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getControlEstadoSerie() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ControlEstadoSerie";
                $s_SQLQuery2 .= $s_Separator."'".$this->getControlEstadoSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SR_Movimiento SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFecha() ) )
            {
                $s_SQLQuery .= $s_Separator."Fecha = '".$this->getFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoMovimiento() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoMovimiento = '".$this->getTipoMovimiento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getOperacion() ) )
            {
                $s_SQLQuery .= $s_Separator."Operacion = '".$this->getOperacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAlmacen() ) )
            {
                $s_SQLQuery .= $s_Separator."Almacen = '".$this->getAlmacen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaTipo() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaTipo = '".$this->getReferenciaTipo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaNumero() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaNumero = '".$this->getReferenciaNumero()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaSecuencia() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaSecuencia = ".$this->getReferenciaSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaId() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaId = '".$this->getReferenciaId()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getReferenciaFecha() ) )
            {
                $s_SQLQuery .= $s_Separator."ReferenciaFecha = '".$this->getReferenciaFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioEscaneo() ) )
            {
                $s_SQLQuery .= $s_Separator."InicioEscaneo = '".$this->getInicioEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinEscaneo() ) )
            {
                $s_SQLQuery .= $s_Separator."FinEscaneo = '".$this->getFinEscaneo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentario() ) )
            {
                $s_SQLQuery .= $s_Separator."Comentario = '".$this->getComentario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioAprob() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioAprob = '".$this->getUsuarioAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaAprob() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaAprob = '".$this->getFechaAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoAprob() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoAprob = '".$this->getEstadoAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getComentarioAprob() ) )
            {
                $s_SQLQuery .= $s_Separator."ComentarioAprob = '".$this->getComentarioAprob()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getImpresionEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."ImpresionEstado = '".$this->getImpresionEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getControlEstadoSerie() ) )
            {
                $s_SQLQuery .= $s_Separator."ControlEstadoSerie = '".$this->getControlEstadoSerie()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  MovimientoId = ".$this->getMovimientoId().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SR_Movimiento WHERE  MovimientoId = ".$this->getMovimientoId().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>